Subject: Re: bug#50042: 26.3; Post-command hooks slow with M-x commands

From: Stefan Monnier <[email-masked]>
Date: Sat, 14 Aug 2021 16:52:27 -0400

>> `execute-extended-command' ends with
>>
>>         (when binding
>>           (with-temp-message
>>               (format-message "You can run the command `%s' with %s"
>>                               function
>>                               (if (stringp binding)
>>                                   (concat "M-x " binding " RET")
>>                                 (key-description binding)))
>>             (sit-for (if (numberp suggest-key-bindings)
>>                          suggest-key-bindings
>>                        2))))))))

Indeed this `sit-for` is a problem because it delays running the
`post-command-hook`.
[ We have a few other such problems, tho I sadly didn't bother to keep
  track of them.  ]

> Stefan, I forgot to put you on the CCs here -- I wondered whether you
> had any ideas here.  I think lifting this out of
> `execute-extended-command' should be possible -- either by doing
> something a la
>
> (run-at-time 0 nil (lambda ()
>                      (with-temp-message "The binding is foo"
> 		       (sit-for 1))))
>
> or making `execute-extended-command' set a variable and do the messaging
> from the "command loop" after running post-command-hook.

Using a timer might be a good option, indeed.

        Stefan